	var manPosition = Array(5);
	var manMoney = Array(5);
	var manColor = Array(5);
	var manName = Array(5);
	
	manMoney[1] = 10000;
	manColor[1] = "white";
	manName[1] = "cow";
	
	manMoney[2] = 10000;
	manColor[2] = "orange";
	manName[2] = "tiger";
	
	manMoney[3] = 10000;
	manColor[3] = "pink";
	manName[3] = "rabbit";
	
	manMoney[4] = 10000;
	manColor[4] = "cyan";
	manName[4] = "dragon";
	
	// 加载xml文档
	loadXML = function(xmlFile)
	{
		var xmlDoc;
		xmlDoc = document.implementation.createDocument('', '', null);
		//设置同步
		xmlDoc.async = false;
		xmlDoc.load(xmlFile);
		return xmlDoc;
	}
	
	//绘制地图
	function DrawMap(map)
	{
		var s = "<div>";
		for(var i=0;i<25;i++)
			for(var j=0;j<25;j++)
			{
				var t = (i+j)*33-223 + "px;left:" + (20+i-j)*66 + "px;' />" 
				if(map[i][j] == 1)
				{
					s += "<img class='map' src='img/way.png' style='top:";
					s += t ;
				}
				if(map[i][j] == 2)
				{
					s += "<img class='map' id='build-";
					s += i;
					s += "-";
					s += j;
					s += "' src='img/build.png' style='top:";
					s += t ;
				}
			}
		s += "</div>";
		return s;
	}
	function MoveMan(n,x,y)
	{
		var o = document.getElementById("man-"+n);
		o.style.top = (x+y)*33-129+"px";
		o.style.left = (20+x-y)*66+"px";
	}

	//创建地图数组
	//25x25
	var map = Array(25);
	for(var i=0;i<25;i++)
	{
		map[i] = Array(25);
	}

	// 读入地图
	var xmlDoc = loadXML('map.xml');

	var nodeTags = xmlDoc.getElementsByTagName("way");
	var length = nodeTags.length;
	var wayX=new Array(length);
	var wayY=new Array(length);
	//可建立建筑物的位置
	var buildX=new Array(length);
	var buildY=new Array(length);
	for(var i=0;i<length;i++)
	{
		wayX[i] = nodeTags[i].getAttribute('x');
		wayY[i] = nodeTags[i].getAttribute('y');
		//1代表道路
		map[wayX[i]][wayY[i]] = 1;
		buildX[i] = nodeTags[i].getAttribute('bx');
		buildY[i] = nodeTags[i].getAttribute('by');
		//2代表可建建筑物
		map[buildX[i]][buildY[i]] = 2;
	}
	//初始化
	function init()
	{
		//设置人物2D位置
		manPosition[1] = 0;
		manPosition[2] = parseInt(length/4);
		manPosition[3] = 	manPosition[2] +	manPosition[2];
		manPosition[4] = 	manPosition[3] +	manPosition[2];
		//设置人物3D位置
		document.getElementById("man-1").style.left = getManXByNumber(1)+"px";
		document.getElementById("man-1").style.top = getManYByNumber(1)+"px";
		document.getElementById("man-2").style.left = getManXByNumber(2)+"px";
		document.getElementById("man-2").style.top = getManYByNumber(2)+"px";
		document.getElementById("man-3").style.left = getManXByNumber(3)+"px";
		document.getElementById("man-3").style.top = getManYByNumber(3)+"px";
		document.getElementById("man-4").style.left = getManXByNumber(4)+"px";
		document.getElementById("man-4").style.top = getManYByNumber(4)+"px";
	}
	//支色子
	function dice(){
		var r = parseInt(Math.random()*6+1);
		var o = document.getElementById("DiceMovie");
		o.src="img/"+r+".gif";
		o.style.visibility="";
		//过一段时间消失
		setTimeout("document.getElementById('DiceMovie').style.visibility='hidden';",1800);
		//色子不可用
		document.getElementById("idDice").style.visibility="hidden";
		document.getElementById("dicedisable").style.visibility="";
		//移动
		for( var i = 0 ; i < r ; i++ )
		{
			setTimeout("setDirect(1,"+(manPosition[1]+i)+");",1800+i*480);
			for(var j=0;j<16;j++)
			{
				setTimeout("document.getElementById('man-1').style.left = "+getManX(manPosition[1]+i,j)+"+'px';",1800+(i*16+j)*30);
				setTimeout("document.getElementById('man-1').style.top = "+getManY(manPosition[1]+i,j)+"+'px';",1800+(i*16+j)*30);
				setTimeout("realTime(1);",1800+(i*16+j)*30);
			}
		}
		manPosition[1]=(manPosition[1]+r)%length;
		setTimeout("MoveEnd();",1800+i*480+480);
	}
	//根据一维位置计算二维位置
	function getManX(i,j)	
	{
		var x1=(20+parseInt(wayX[i%length]-wayY[i%length]))*66;
		var x2=(20+parseInt(wayX[(i+1)%length]-wayY[(i+1)%length]))*66;
		var x3=(x2-x1)*j/16;
		return(parseInt(x1+x3));
	}
	function getManY(i,j)	
	{
		var y1=(parseInt(wayX[i%length])+parseInt(wayY[i%length]))*33-129;
		var y2=(parseInt(wayX[(i+1)%length])+parseInt(wayY[(i+1)%length]))*33-129;
		var y3=(y2-y1)*j/16;
		return(parseInt(y1+y3));
	}
	//建立建筑
	function buildButton(n)
	{
		var position = manPosition[n];
		var x=buildX[position];
		var y=buildY[position];
		//把地划分给玩家
		map[x][y] = n*100+1;
		//改变地形
		document.getElementById("build-"+x+"-"+y).src="img/"+manColor[n]+"-1.gif";
		//扣除金币
		manMoney[n]-=500;
		document.getElementById("money").innerHTML = "金币："+ manMoney[1];
	}
	//移动完毕后的工作
	function MoveEnd()
	{
		var x=parseInt(buildX[manPosition[1]]);
		var y=parseInt(buildY[manPosition[1]]);
		//这块地是空的
		if(map[x][y]==2)
		{
			//有足够的钱买这块地
			if(manMoney[1]>=500)
			{
				//弹出对话框
				var Dialog = document.getElementById("Dialog");
				var canvasDialogBack = document.getElementById("canvasDialogBack");
				var DialogWidth = parseInt(Dialog.style.width);
				var DialogHeight = parseInt(Dialog.style.height);
				Dialog.style.left = Dialog.style.right = (document.documentElement.clientWidth-DialogWidth)/2+"px";
				Dialog.style.top = (document.documentElement.clientHeight-DialogHeight)/2+"px";
				document.getElementById('Dialog').style.visibility='';
				if (canvasDialogBack.getContext)
				{
					var ctx = canvasDialogBack.getContext('2d');
					//设置渐变
					var gradient = ctx.createLinearGradient(150, 0, 150, 150);
					gradient.addColorStop(0, 'rgba(255,255,255,0.85)');
					gradient.addColorStop(0.2, 'rgba(210,210,210,0.8)');
					gradient.addColorStop(0.8, 'rgba(200,200,200,0.8)');
					gradient.addColorStop(1, 'rgba(250,250,250,0.85)');
					ctx.fillStyle=gradient;
					//清除
					ctx.clearRect(0,0,300,150);
			
					ctx.shadowBlur = 9;
					ctx.shadowColor = 'rgba(42, 42, 42, 0.6)';
					//绘图
					ctx.beginPath();
					ctx.moveTo(40,10);
					ctx.lineTo(260,10);
					ctx.quadraticCurveTo(290,10,290,40);
					ctx.lineTo(290,110);
					ctx.quadraticCurveTo(290,140,260,140);
					ctx.lineTo(40,140);
					ctx.quadraticCurveTo(10,140,10,110);
					ctx.lineTo(10,40);
					ctx.quadraticCurveTo(10,10,40,10);
					ctx.fill();
				}
				document.getElementById("DialogTable").innerHTML="这块地还没有人开发，您愿意购买这块地吗？";
				document.getElementById("DialogTableSmall").innerHTML="购买这块地，需要500金币，您现在有"+manMoney[1]+"金币";
			}
			else
			{
				//没有钱则让下一个玩家支色子
				autoDice(2);
			}
		}
		//这块地是自己的
		else if(map[x][y]>100&&map[x][y]<200)
		{
			autoDice(2);
		}
		//这块地是别人的
		else
		{
			//收钱
			manMoney[1]-=20;
			manMoney[parseInt(map[x][y]/100)]+=20;
			//显示动画
			document.getElementById('MoneyMovie').style.left = (20+parseInt(wayX[manPosition[1]])-parseInt(wayY[manPosition[1]]))*66-100+"px";
			document.getElementById('MoneyMovie').style.top = (parseInt(wayX[manPosition[1]])+parseInt(wayY[manPosition[1]]))*33-129+"px";
			document.getElementById('MoneyMovie').style.visibility="";
			document.getElementById('MoneyMovie').src = "";
			document.getElementById('MoneyMovie').src = "img/MoneyMovie.gif";
			//刷新金额
			setTimeout("document.getElementById('money').innerHTML = '金币：'+ manMoney[1];",2000);
			setTimeout("autoDice(2);",2000);
		}
	}
	//单击建设按钮
	function onBuildButton()
	{
		document.getElementById('Dialog').style.visibility="hidden";
		//买地
		buildButton(1);
		//1秒后，让下一个玩家支色子
		setTimeout("autoDice(2);",1000);
	}
	//单击取消按钮
	function cancel()
	{
		document.getElementById('Dialog').style.visibility="hidden";
		autoDice(2);
	}
	//电脑玩家移动后
	function autoMoveEnd(n)
	{
		var x=parseInt(buildX[manPosition[n]]);
		var y=parseInt(buildY[manPosition[n]]);
		//这块地是空的
		if(map[x][y]==2)
		{
			if(manMoney[n]>=500)
			{
				//买地
				buildButton(n);
				setTimeout("autoDice("+(n+1)+");",2000);
			}
			else
				//让下一位玩家支色子
				autoDice(n+1);
		}
		//这块地是自己的
		else if(map[x][y]>n*100&&map[x][y]<n*100+100)
		{
			autoDice(n+1);
		}
		//这块地是别人的
		else
		{
			//收钱
			manMoney[n]-=20;
			manMoney[parseInt(map[x][y]/100)]+=20;
			//显示动画
			document.getElementById('MoneyMovie').style.left = (20+parseInt(wayX[manPosition[n]])-parseInt(wayY[manPosition[n]]))*66-100+"px";
			document.getElementById('MoneyMovie').style.top = (parseInt(wayX[manPosition[n]])+parseInt(wayY[manPosition[n]]))*33-129+"px";
			document.getElementById('MoneyMovie').style.visibility="";
			document.getElementById('MoneyMovie').src = "";
			document.getElementById('MoneyMovie').src = "img/MoneyMovie.gif";
			//刷新金额
			setTimeout("document.getElementById('money').innerHTML = '金币：'+ manMoney[1];",2000);
			setTimeout("autoDice("+(n+1)+");",2000);
		}
	}
	//让电脑支色子
	function autoDice(n)
	{
		//防止出错
		if(n>=5)
		{
			firstMan();
			return;
		}
		//如果需要滚动滚动条，先滚动滚动条，稍后重新执行这个函数
		if(manFocus(n))
		{
			setTimeout("autoDice("+n+");",1500);
			return;
		}
		var r = parseInt(Math.random()*6+1);
		var position = manPosition[n];
		for( var i = 0 ; i < r ; i++ )
		{
			setTimeout("setDirect("+n+","+(position+i)+");",1800+i*480);
			for(var j=0;j<16;j++)
			{
				setTimeout("document.getElementById('man-"+n+"').style.left = '"+getManX(position+i,j)+"px';",1800+(i*16+j)*30);
				setTimeout("document.getElementById('man-"+n+"').style.top = '"+getManY(position+i,j)+"px';",1800+(i*16+j)*30);
				setTimeout("realTime("+n+");",1800+(i*16+j)*30);
			}
		}
		manPosition[n]=(position+r)%length;
		setTimeout("autoMoveEnd("+n+");",1800+i*480+480);
	}
	//判断人物是不是在滚动区域以外，如果是，将滚动区域瞄准人物，并且返回true
	function manFocus(n)
	{
		var r = false;
		var x = getManXByNumber(n);
		var y = getManYByNumber(n);
		var scrollX=0,scrollY=0;
		//检查横向滚动条是否需要滚动
		if(x<document.documentElement.scrollLeft+180)
		{
			//向左滚动
			scrollX = parseInt((x-document.documentElement.scrollLeft-230)/32);
			r = true;
		}
		else if(x>document.documentElement.scrollLeft+document.documentElement.clientWidth-211)
		{
			//向右滚动
			scrollX = parseInt((x-document.documentElement.scrollLeft-document.documentElement.clientWidth+261)/32);
			r = true;
		}
		if(y<document.documentElement.scrollTop+20)
		{
			//向上滚动
			scrollY = parseInt((y-document.documentElement.scrollTop-70)/32);
			r = true;
		}
		else if(y>document.documentElement.scrollTop+document.documentElement.clientHeight-200)
		{
			//向下滚动
			scrollY = parseInt((y-document.documentElement.scrollTop-document.documentElement.clientHeight+250)/32);
			r = true;
		}
		if(r)
		{
			for(var i=0;i<32;i++)
				setTimeout("scrollBy("+scrollX+","+scrollY+");",i*50);

		}
		return r;
	}
	function getManXByNumber(n)
	{
		return (20+parseInt(wayX[manPosition[n]]-wayY[manPosition[n]]))*66;
	}
	function getManYByNumber(n)
	{
		return (parseInt(wayX[manPosition[n]])+parseInt(wayY[manPosition[n]]))*33-129;
	}
	//滚动窗口、恢复色子图标
	function firstMan()
	{
		if(manFocus(1))
		{
			setTimeout("document.getElementById('idDice').style.visibility='';",2000);
			setTimeout("document.getElementById('dicedisable').style.visibility='hidden';",2000);
		}
		else
		{
			document.getElementById('idDice').style.visibility='';
			document.getElementById('dicedisable').style.visibility='hidden';
		}
	}
	//随时检测人物有没有跑到滚动区域以外
	function realTime(n)
	{
		var r = false;
		var x = getManXByNumber(n);
		var y = getManYByNumber(n);
		var scrollX=0,scrollY=0;
		//检查横向滚动条是否需要滚动
		if(x<document.documentElement.scrollLeft+180)
		{
			//向左滚动
			scrollX = -4;
			r = true;
		}
		else if(x>document.documentElement.scrollLeft+document.documentElement.clientWidth-211)
		{
			//向右滚动
			scrollX = 4;
			r = true;
		}
		if(y<document.documentElement.scrollTop+20)
		{
			//向上滚动
			scrollY = -2;
			r = true;
		}
		else if(y>document.documentElement.scrollTop+document.documentElement.clientHeight-200)
		{
			//向下滚动
			scrollY = 2;
			r = true;
		}
		if(r)
			scrollBy(scrollX,scrollY);
	}
	//获得当前人物的朝向
	function getDirect(n,p)
	{
		var x1 = parseInt(wayX[p%length]);
		var y1 = parseInt(wayY[p%length]);
		var x2 = parseInt(wayX[(p+1)%length]);
		var y2 = parseInt(wayY[(p+1)%length]);
		if(x1>x2)
			return "q";
		else if(x1<x2)
			return "b";
		else if(y1>y2)
			return "p";
		else
			return "d";
	}
	function setDirect(n,p)
	{
		document.getElementById("man-"+n).src="img/man-"+manName[n]+"-"+getDirect(n,p)+".gif";
	}
